Exiv2::FileIo Class Reference

Provides binary file IO by implementing the BasicIo interface. More...

`#include <basicio.hpp>`

Inheritance diagram for Exiv2::FileIo:
[legend]

## Classes

class | Impl
| Internal Pimpl structure of class FileIo. More...

## Public Member Functions

Creators
| FileIo (const std::string &path)
| Constructor that accepts the file path on which IO will be performed. The constructor does not open the file, and therefore never failes. More...
virtual | ~FileIo ()
| Destructor. Flushes and closes an open file.
Manipulators
int | open (const std::string &mode)
| Open the file using using the specified mode. More...
virtual int | open ()
| Open the file using using the default access mode of "rb". This method can also be used to "reopen" a file which will flush any unwritten data and reset the IO position to the start. More...
virtual int | close ()
| Flush and unwritten data and close the file . It is safe to call close on an already closed instance. More...
virtual long | write (const byte *data, long wcount)
| Write data to the file. The file position is advanced by the number of bytes written. More...
virtual long | write (BasicIo &src)
| Write data that is read from another BasicIo instance to the file. The file position is advanced by the number of bytes written. More...
virtual int | putb (byte data)
| Write one byte to the file. The file position is advanced by one byte. More...
virtual DataBuf | read (long rcount)
| Read data from the file. Reading starts at the current file position and the position is advanced by the number of bytes read. More...
virtual long | read (byte *buf, long rcount)
| Read data from the file. Reading starts at the current file position and the position is advanced by the number of bytes read. More...
virtual int | getb ()
| Read one byte from the file. The file position is advanced by one byte. More...
virtual void | transfer (BasicIo &src)
| Remove the contents of the file and then transfer data from the src BasicIo object into the empty file. More...
virtual int | seek (long offset, Position pos)
| Move the current file position. More...
virtual byte * | mmap (bool isWriteable=false)
| Map the file into the process's address space. The file must be open before mmap() is called. If the mapped area is writeable, changes may not be written back to the underlying file until munmap() is called. The pointer is valid only as long as the FileIo object exists. More...
virtual int | munmap ()
| Remove a mapping established with mmap(). If the mapped area is writeable, this ensures that changes are written back to the underlying file. More...
virtual void | setPath (const std::string &path)
| close the file source and set a new path.
Public Member Functions inherited from Exiv2::BasicIo
virtual | ~BasicIo ()
| Destructor.

## Accessors

virtual long | tell () const
| Get the current file position. More...
virtual size_t | size () const
| Flush any buffered writes and get the current file size in bytes. More...
virtual bool | isopen () const
| Returns true if the file is open, otherwise false.
virtual int | error () const
| Returns 0 if the file is in a valid state, otherwise nonzero.
virtual bool | eof () const
| Returns true if the file position has reached the end, otherwise false.
virtual std::string | path () const
| Returns the path of the file.
virtual void | populateFakeData ()
| Mark all the bNone blocks to bKnow. This avoids allocating memory for parts of the file that contain image-date (non-metadata/pixel data) More...

## Additional Inherited Members

Public Types inherited from Exiv2::BasicIo
enum | Position { beg , cur , end }
| Seek starting positions.
typedef std::auto_ptr< BasicIo > | AutoPtr
| BasicIo auto_ptr type.
Public Attributes inherited from Exiv2::BasicIo
byte * | bigBlock_
| this is allocated and populated by mmap()
Protected Member Functions inherited from Exiv2::BasicIo
| BasicIo ()
| Default Constructor.

## Detailed Description

Provides binary file IO by implementing the BasicIo interface.

Examples
  metacopy.cpp, and mrwthumb.cpp.

## Constructor & Destructor Documentation

## FileIo()

Exiv2::FileIo::FileIo | ( | const std::string & | path | ) |

explicit

Constructor that accepts the file path on which IO will be performed. The constructor does not open the file, and therefore never failes.

Parameters

  path | The full path of a file

## Member Function Documentation

## close()

int Exiv2::FileIo::close | ( |  | ) |

virtual

Flush and unwritten data and close the file . It is safe to call close on an already closed instance.

Returns
  0 if successful;
  Nonzero if failure;

Implements Exiv2::BasicIo.

Examples
  mrwthumb.cpp.

References munmap().

Referenced by open(), setPath(), transfer(), and ~FileIo().

## getb()

int Exiv2::FileIo::getb | ( |  | ) |

virtual

Read one byte from the file. The file position is advanced by one byte.

Returns
  The byte read from the file if successful;
  EOF if failure;

Implements Exiv2::BasicIo.

## mmap()

byte * Exiv2::FileIo::mmap | ( | bool | isWriteable = `false` | ) |

virtual

Map the file into the process's address space. The file must be open before mmap() is called. If the mapped area is writeable, changes may not be written back to the underlying file until munmap() is called. The pointer is valid only as long as the FileIo object exists.

Parameters

  isWriteable | Set to true if the mapped area should be writeable (default is false).

Returns
  A pointer to the mapped area.

Exceptions

  Error | In case of failure.

Implements Exiv2::BasicIo.

References munmap().

## munmap()

int Exiv2::FileIo::munmap | ( |  | ) |

virtual

Remove a mapping established with mmap(). If the mapped area is writeable, this ensures that changes are written back to the underlying file.

Returns
  0 if successful;
  Nonzero if failure;

Implements Exiv2::BasicIo.

References seek(), and write().

Referenced by close(), and mmap().

## open() [1/2]

int Exiv2::FileIo::open | ( |  | ) |

virtual

Open the file using using the default access mode of "rb". This method can also be used to "reopen" a file which will flush any unwritten data and reset the IO position to the start.

Returns
  0 if successful;
  Nonzero if failure.

Implements Exiv2::BasicIo.

Referenced by transfer().

## open() [2/2]

int Exiv2::FileIo::open | ( | const std::string & | mode | ) |

Open the file using using the specified mode.

This method can also be used to "reopen" a file which will flush any unwritten data and reset the IO position to the start. Although files can be opened in binary or text mode, this class has only been tested carefully in binary mode.

Parameters

  mode | Specified that type of access allowed on the file. Valid values match those of the C fopen command exactly.

Returns
  0 if successful;
  Nonzero if failure.

Examples
  mrwthumb.cpp.

References close(), and path().

Referenced by Exiv2::readFile(), and Exiv2::writeFile().

## populateFakeData()

void Exiv2::FileIo::populateFakeData | ( |  | ) |

virtual

Mark all the bNone blocks to bKnow. This avoids allocating memory for parts of the file that contain image-date (non-metadata/pixel data)

Note
  This method should be only called after the concerned data (metadata) are all downloaded from the remote file to memory.

Reimplemented from Exiv2::BasicIo.

## putb()

int Exiv2::FileIo::putb | ( | byte | data | ) |

virtual

Write one byte to the file. The file position is advanced by one byte.

Parameters

  data | The single byte to be written.

Returns
  The value of the byte written if successful;
  EOF if failure;

Implements Exiv2::BasicIo.

## read() [1/2]

long Exiv2::FileIo::read | ( | byte * | buf,
|  | long | rcount
| ) |  |

virtual

Read data from the file. Reading starts at the current file position and the position is advanced by the number of bytes read.

Parameters

  buf | Pointer to a block of memory into which the read data is stored. The memory block must be at least rcount bytes long.
  rcount | Maximum number of bytes to read. Fewer bytes may be read if rcount bytes are not available.

Returns
  Number of bytes read from the file successfully;
  0 if failure;

Implements Exiv2::BasicIo.

## read() [2/2]

DataBuf Exiv2::FileIo::read | ( | long | rcount | ) |

virtual

Read data from the file. Reading starts at the current file position and the position is advanced by the number of bytes read.

Parameters

  rcount | Maximum number of bytes to read. Fewer bytes may be read if rcount bytes are not available.

Returns
  DataBuf instance containing the bytes read. Use the DataBuf::size_ member to find the number of bytes read. DataBuf::size_ will be 0 on failure.

Implements Exiv2::BasicIo.

References size().

## seek()

int Exiv2::FileIo::seek | ( | long | offset,
|  | Position | pos
| ) |  |

virtual

Move the current file position.

Parameters

  offset | Number of bytes to move the file position relative to the starting position specified by pos
  pos | Position from which the seek should start

Returns
  0 if successful;
  Nonzero if failure;

Implements Exiv2::BasicIo.

Referenced by munmap().

## size()

size_t Exiv2::FileIo::size | ( |  | ) | const

virtual

Flush any buffered writes and get the current file size in bytes.

Returns
  Size of the file in bytes;
  -1 if failure;

Implements Exiv2::BasicIo.

References Exiv2::FileIo::Impl::StructStat::st_size.

Referenced by read(), and Exiv2::XPathIo::writeDataToFile().

## tell()

long Exiv2::FileIo::tell | ( |  | ) | const

virtual

Get the current file position.

Returns
  Offset from the start of the file if successful;
  -1 if failure;

Implements Exiv2::BasicIo.

## transfer()

void Exiv2::FileIo::transfer | ( | BasicIo & | src | ) |

virtual

Remove the contents of the file and then transfer data from the src BasicIo object into the empty file.

This method is optimized to simply rename the source file if the source object is another FileIo instance. The source BasicIo object is invalidated by this operation and should not be used after this method returns. This method exists primarily to be used with the BasicIo::temporary() method.

Note
  If the caller doesn't have permissions to write to the file, an exception is raised and src is deleted.

Parameters

  src | Reference to another BasicIo instance. The entire contents of src are transferred to this object. The src object is invalidated by the method.

Exceptions

  Error | In case of failure

Implements Exiv2::BasicIo.

Reimplemented in Exiv2::XPathIo.

References close(), open(), and path().

Referenced by Exiv2::XPathIo::transfer().

## write() [1/2]

long Exiv2::FileIo::write | ( | BasicIo & | src | ) |

virtual

Write data that is read from another BasicIo instance to the file. The file position is advanced by the number of bytes written.

Parameters

  src | Reference to another BasicIo instance. Reading start at the source's current IO position

Returns
  Number of bytes written to the file successfully;
  0 if failure;

Implements Exiv2::BasicIo.

References Exiv2::BasicIo::isopen(), Exiv2::BasicIo::read(), and Exiv2::BasicIo::seek().

## write() [2/2]

long Exiv2::FileIo::write | ( | const byte * | data,
|  | long | wcount
| ) |  |

virtual

Write data to the file. The file position is advanced by the number of bytes written.

Parameters

  data | Pointer to data. Data must be at least wcount bytes long
  wcount | Number of bytes to be written.

Returns
  Number of bytes written to the file successfully;
  0 if failure;

Implements Exiv2::BasicIo.

Examples
  mrwthumb.cpp.

Referenced by munmap().

The documentation for this class was generated from the following files:

- basicio.hpp
- basicio.cpp